<?php
/* Administration */
require( "../../userdata/config.php" );
require( SMARTY_DIR . "Smarty.class.php" );
require( "../functions.php" );
require( "../classMysql.php" );
require( "../classMySmarty.php" );
require( "../classTextile.php" );

$db = new DB_mysql;
$tt = new Textile;

initVar( "p0", "" );
initVar( "p1", "" );
initVar( "p2", "" );
initVar( "site", "start" );

/* Language thingi */
session_start();
if (!isset($_SESSION['lang'])) {
  $_SESSION['lang'] = getSetting( "default_language" );
}
$lang = $_SESSION['lang'];

if( $site == "setlang" ) {
  $_SESSION['lang'] = $p0;
  $site = "start";
}

$db->query( "SELECT * FROM `languages`" );
$i = 0;
while ($db->next_record()) {
  $lang_urls[] = "/admin/?site=setlang&amp;p0=" . $db->f( "lang" );
  $lang_names[] = $db->f( "name" );
  $lang_imgs[] = $db->f( "src_img" );
  $lang_shorts[] = $db->f( "lang" );
  $lang_defaults[] = $db->f( "default_site" );
  if( $lang == $db->f( "lang" )) {
    $lang_selected = $i;
    require( "../lang_" . $lang . ".php" );
  }
  $i++;
}

if( !isset( $lang_selected )) {
  $lang = getSetting( "default_language" );
  require( "../lang_" . $lang . ".php" );
}

/* This should be replaced with a proper solution: */
$p = array( $lang, $p0, $p1, $p2 );

/* Build Menu */

$menu_urls = array(
 "?site=sites",
 "?site=menu"
//  "?site=images",
// "?site=files"
);
$menu_names = array( 
 "Seiten",
 "Men"
//  "Bilder",
// "Dateien"
);
 $menu_selected = -1;

/* Load Modules */
$mod_dir = dir('..');
while( $mod_file = $mod_dir->read( )) {
  if( ereg( 'mod_([a-z]*)\.php', $mod_file, $mod_name )) {
    require( "../" . $mod_file );
    $menu_urls = array_merge( $menu_urls, call_user_func( "menu_urls_" . $mod_name[1] ));
    $menu_names = array_merge( $menu_names, call_user_func( "menu_names_" . $mod_name[1] ));
  }
}


/* Pre Function */
if( function_exists( $site ) && substr( $site, 0, 3 ) == "pre" ) {
  $site = call_user_func( $site, $p );
} else if( $site == "site_del" ) {
  $path = makeCleanPath( initVar( "path", "" ));
  $db->query( "DELETE FROM `sites` WHERE `path` = '" . $path . "' AND `name` = '" . $p0 . "' AND `language` = '" . $lang . "'" );
  $site = "sites";

} else if ( $site == "site_save" ) {
  initPVar( "site_name", "Neue Seite" );
  initPVar( "site_content", "" );
  initPVar( "site_count", "0" );
  $path = makeCleanPath( initPVar( "path", "" ));
  if( $site_name != "Neue Seite" ) {
    $db->query( "DELETE FROM `sites` WHERE `path` = '" . $path . "' AND `name` = '" . $site_name . "' AND `language` = '" . $lang . "'" );
    $db->query( "INSERT INTO `sites` (`name`, `content`, `content_cached`, `language`, `count`, `path`) ".
                "VALUES ('" . $site_name . "', '" . $site_content . "', '" . $tt->TextileThis( $site_content ) . "', '" . $lang . "', '" . $site_count . "', '" . $path . "') " );
  }
  $site = "sites";

} else if ( $site == "site_mkdir" ) {
  initPVar( "name", "" );
  $path = makeCleanPath( initPVar( "path", "" ));
  if( $name != "" ) {
    $db->query( "DELETE FROM `site_dirs` WHERE `path` = '" . $path . "' AND `name` = '" . $name . "' AND `language` = '" . $lang . "'" );
    $db->query( "INSERT INTO `site_dirs` (`name`, `language`, `path`) ".
                "VALUES ('" . $name . "', '" . $lang . "', '" . $path . "') " );
  }
  $site = "sites";

} else if ( $site == "site_rmdir" ) {
  initVar( "name", "" );
  $path = makeCleanPath( initVar( "path", "" ));
  if( $name != "" ) {
    $db->query( "DELETE FROM `sites` WHERE `path` LIKE '" . makeCleanPath( $path . $name ) . "%' AND `language` = '" . $lang . "'" );
    $db->query( "DELETE FROM `site_dirs` WHERE `path` LIKE '" . makeCleanPath( $path . $name ) . "%' AND `language` = '" . $lang . "'" );
    $db->query( "DELETE FROM `site_dirs` WHERE `path` = '" . $path . "' AND `name` = '" . $name . "' AND `language` = '" . $lang . "'" );
  }
  $site = "sites";

} else if ( $site == "menu_del" ) {
  $path = makeCleanPath( initVar( "path", "" ));
  $db->query( "DELETE FROM `menu` WHERE `path` = '" . $path . "' AND `name` = '" . $p0 . "' AND `lang` = '" . $lang . "'" );
  $site = "menu";

} else if ( $site == "menu_save" ) {
  $path = makeCleanPath( initPVar( "path", "" ));
  initPVar( "menu_name", "Neuer Menpunkt" );
  initPVar( "menu_href", "" );
  initPVar( "menu_id", "" );
  if( $site_name != "Neuer Menpunkt" ) {
    $db->query( "DELETE FROM `menu` WHERE `path` = '" . $path . "' AND `name` = '" . $menu_name . "' AND `lang` = '" . $lang . "'" );
    $db->query( "INSERT INTO `menu` (`name`, `href`, `lang`, `path`, `id`) ".
                "VALUES ('" . $menu_name . "', '" . $menu_href . "', '" . $lang . "', '" . $path . "', '" . $menu_id . "') " );
  }
  $site = "menu";

} else if ( $site == "menu_up" ) {
  $path = makeCleanPath( initVar( "path", "" ));
  if( $p0 != "" ) {
    $db->query( "SELECT `id` FROM `menu` WHERE `path` = '" . $path . "' AND `lang` = '" . $lang . "' AND `name` = '" . $p0 . "' LIMIT 1" );
    $db->next_record();
    $ida = $db->f( "id" );
    $db->query( "SELECT `id` FROM `menu` WHERE `path` = '" . $path . "' AND `lang` = '" . $lang . "' AND `id` < " . $ida . " ORDER BY `id` DESC LIMIT 1" );
    if( $db->next_record()) {
      $idb = $db->f( "id" );
      $db->query( "UPDATE `menu` SET `id` = '" . $ida . "' WHERE `path` = '" . $path . "' AND `lang` = '" . $lang . "' AND `id` = '" . $idb . "'" );
      $db->query( "UPDATE `menu` SET `id` = '" . $idb . "' WHERE `path` = '" . $path . "' AND `lang` = '" . $lang . "' AND `id` = '" . $ida
                   . "' AND `name` = '" . $p0 . "'" );
    }
  }
  $site = "menu";

} else if ( $site == "menu_down" ) {
  $path = makeCleanPath( initVar( "path", "" ));
  if( $p0 != "" ) {
    $db->query( "SELECT `id` FROM `menu` WHERE `path` = '" . $path . "' AND `lang` = '" . $lang . "' AND `name` = '" . $p0 . "' LIMIT 1" );
    $db->next_record();
    $ida = $db->f( "id" );
    $db->query( "SELECT `id` FROM `menu` WHERE `path` = '" . $path . "' AND `lang` = '" . $lang . "' AND `id` > " . $ida . " ORDER BY `id` ASC LIMIT 1" );
    if( $db->next_record()) {
      $idb = $db->f( "id" );
      $db->query( "UPDATE `menu` SET `id` = '" . $ida . "' WHERE `path` = '" . $path . "' AND `lang` = '" . $lang . "' AND `id` = '" . $idb . "'" );
      $db->query( "UPDATE `menu` SET `id` = '" . $idb . "' WHERE `path` = '" . $path . "' AND `lang` = '" . $lang . "' AND `id` = '" . $ida
                   . "' AND `name` = '" . $p0 . "'" );
    }
  }
  $site = "menu";

} else if ( $site == "menu_mkdir" ) {
  initPVar( "name", "" );
  $path = makeCleanPath( initPVar( "path", "" ));
  if( $name != "" ) {
    $db->query( "DELETE FROM `menu_dirs` WHERE `path` = '" . $path . "' AND `name` = '" . $name . "' AND `language` = '" . $lang . "'" );
    $db->query( "INSERT INTO `menu_dirs` (`name`, `language`, `path`) ".
                "VALUES ('" . $name . "', '" . $lang . "', '" . $path . "') " );
  }
  $site = "menu";

} else if ( $site == "menu_rmdir" ) {
  initVar( "name", "" );
  $path = makeCleanPath( initVar( "path", "" ));
  if( $name != "" ) {
    $db->query( "DELETE FROM `menu` WHERE `path` LIKE '" . makeCleanPath( $path . $name ) . "%' AND `lang` = '" . $lang . "'" );
    $db->query( "DELETE FROM `menu_dirs` WHERE `path` LIKE '" . makeCleanPath( $path . $name ) . "%' AND `language` = '" . $lang . "'" );
    $db->query( "DELETE FROM `menu_dirs` WHERE `path` = '" . $path . "' AND `name` = '" . $name . "' AND `language` = '" . $lang . "'" );
  }
  $site = "menu";


} else if ( $site == "image_upload" ) {
  if( @is_uploaded_file( $_FILES["image"]["tmp_name"] )) {
    $newname = makeCleanString( $_FILES["image"]["name"] );
    $newname = ereg_replace( " ", "_", $newname );
    copy( $_FILES["image"]["tmp_name"], "../../userdata/img/" . $newname );
  }
  $site = "images";

} else if ( $site == "image_delete" ) {
  unlink( "../../userdata/img/" . $p0 );
  $site = "images";

} else if ( $site == "file_upload" ) {
  if( @is_uploaded_file( $_FILES["file"]["tmp_name"] )) {
    $newname = makeCleanString( $_FILES["file"]["name"] );
    $newname = ereg_replace( " ", "_", $newname );
    copy( $_FILES["file"]["tmp_name"], "../../userdata/files/" . $newname );
  }
  $site = "files";

} else if ( $site == "file_delete" ) {
  unlink( "../../userdata/files/" . $p0 );
  $site = "files";
}

/* Functions */
if( function_exists( $site )) {
  $content = call_user_func( $site, $p );
} else if( $site == "start" ) {
  $content .= "Willkommen im Administrations Panel";

} else if( $site == "sites" ) {
  if( !isset( $path ))
    $path = initVar( "path", "" );
  $path = makeCleanPath( $path );
  $updir = makeCleanPath( dirname( "/" . $path ));
  $db2 = new DB_mysql;
  $content .= "<a href=\"?site=site_edit&amp;p0=Neue%20Seite&amp;path=" . $path . "\">Neue Seite anlegen</a><br /><br />";
  $content .= "<form action=\"?site=site_mkdir\" method=\"post\">"
            . "<input type=\"hidden\" name=\"path\" value=\"" . $path . "\" />"
            . "Neuen Ordner erstellen: <input name=\"name\" type=\"text\" />"
            . " &nbsp; <input type=\"submit\" value=\"Ok\" /></form><br />";
  $content .= "<br /><table class=\"bt\">";
  if( $path != "/" ) {
    $content .= "<tr><td><img src=\"/theme/img/dir-small.png\" /></td><td><a href=\"?site=sites&amp;path=" . $updir . "\">" .
              "( Aufwrts )</a></td><td colspan=\"2\"></td></tr>";
  }
  $sumdircount = 0;
  $db->query( "SELECT `name` FROM `site_dirs` WHERE `path` = '" . $path . "' AND `language` = '" . $lang . "' ORDER BY `name`" );
  while ($db->next_record()) {
    $db2->query( "SELECT SUM(`count`) AS `count` FROM `sites` WHERE `path` LIKE '" . makeCleanPath( $path . $db->f( "name" ) ) . "%' AND `language` = '" . $lang . "'" );
    $db2->next_record();
    $content .= "<tr><td><img src=\"/theme/img/dir-small.png\" /></td><td><a href=\"?site=sites&amp;path=" . $path . $db->f( "name" ) . "/\">" . $db->f( "name" ) .
              "</a></td><td>( <a href=\"?site=site_rmdir&amp;path=" . $path . "&amp;name=" . $db->f( "name" ) . "\"  onclick=\"return sendFormular();\">Lschen</a> )</td>" .
              "<td>(Downloads: " . intval( $db2->f( "count" )) . ")</td></tr>";
    $sumdircount += $db2->f( "count" );
  }

  $db->query( "SELECT `name`, `count` FROM `sites` WHERE `path` = '" . $path . "' AND `language` = '" . $lang . "' ORDER BY `name`" );
  $sumcount = 0;
  while ($db->next_record()) {
    $content .= "<tr><td><img src=\"/theme/img/file-small.png\" /></td><td><a href=\"?site=site_edit&amp;p0=" . replaceWhitespace( $db->f( "name" )) . "&amp;path=" . $path . "\">" . $db->f( "name" ) . 
              "</a></td><td>( <a href=\"?site=site_del&amp;p0=" . replaceWhitespace( $db->f( "name" )) .  "&amp;path=" . $path . "\"  onclick=\"return sendFormular();\">Lschen</a> )</td>" . 
              "<td>(Downloads: " .  $db->f( "count" ) . ")</td></tr>";
    $sumcount += $db->f( "count" );
  }
  $content .= "<tr><td colspan=\"3\">&nbsp;</td></tr>";
  $content .= "<tr><td colspan=\"3\">Gesamt:</td><td>(Downloads: " . ($sumdircount + $sumcount) . " / " . $sumcount . ")</td></tr>";
  $content .= "</table>";

} else if ( $site == "site_edit" ) {
  $path = makeCleanPath( initVar( "path", "" ));
  $db->query( "SELECT `content`, `count` FROM `sites` WHERE `path` = '" . $path . "' AND `language` = '" . $lang . "' AND `name` = '". $p0 . "'" );
  $site_name = "Neue Seite";
  $site_content = "";
  if( $db->next_record()) {
    $site_name = $p0;
    $site_content = $db->f( "content" );
  }
  $content .= "<form action=\"?site=site_save\" method=\"post\"><input type=\"hidden\" name=\"site_count\" value=\"" . $db->f( "count" ) . "\">
              <input type=\"hidden\" name=\"path\" value=\"" . $path . "\">
              <table class=\"bt\"><tr><td>Name: </td><td><input type=\"text\" name=\"site_name\" value=\""
              . $site_name . "\" /></td></tr><tr><td>Text: </td><td>
              <textarea name=\"site_content\" rows=\"15\" cols=\"60\">" . $site_content . "</textarea>
              </td></tr><tr><td colspan=\"2\"><input type=\"submit\" value=\"Speichern\" /> <input type=\"reset\" value=\"Original\" /></td></tr></table></form>";

} else if( $site == "menu" ) {
  if( !isset( $path ))
    $path = initVar( "path", "" );
  $path = makeCleanPath( $path );
  $updir = makeCleanPath( dirname( "/" . $path ));
  $content .= "<a href=\"?site=menu_edit&amp;p0=Neuer%20Menpunkt&amp;path=" . $path . "\">Neuer Menpunkt</a><br />";
  $content .= "<form action=\"?site=menu_mkdir\" method=\"post\">"
            . "<input type=\"hidden\" name=\"path\" value=\"" . $path . "\" />"
            . "Neuen Ordner erstellen: <input name=\"name\" type=\"text\" />"
            . " &nbsp; <input type=\"submit\" value=\"Ok\" /></form><br />";
  $content .= "<br /><table class=\"bt\">";
  if( $path != "/" ) {
    $content .= "<tr><td><img src=\"/theme/img/dir-small.png\" /></td><td><a href=\"?site=menu&amp;path=" . $updir . "\">" .
              "( Aufwrts )</a></td><td colspan=\"2\"></td></tr>";
  }
  $db->query( "SELECT `name` FROM `menu_dirs` WHERE `path` = '" . $path . "' AND `language` = '" . $lang . "' ORDER BY `name`" );
  while ($db->next_record()) {
    $content .= "<tr><td><img src=\"/theme/img/dir-small.png\" /></td><td><a href=\"?site=menu&amp;path=" . $path . $db->f( "name" ) . "/\">" . $db->f( "name" ) .
              "</a></td><td></td><td>( <a href=\"?site=menu_rmdir&amp;path=" . $path . "&amp;name=" . $db->f( "name" ) . "\"  onclick=\"return sendFormular();\">Lschen</a> )</td>" .
              "</tr>";
  }

  $db->query( "SELECT `name` FROM `menu` WHERE `path` = '" . $path . "' AND `lang` = '" . $lang . "' ORDER BY `id`" );
  while ($db->next_record()) {
    $content .= "<tr><td>&bull;</td><td> <a href=\"?site=menu_edit&amp;path=" . $path . "&amp;p0=" . replaceWhitespace( $db->f( "name" )) . "\">" . $db->f( "name" ) .
              "</a></td><td>( <a href=\"?site=menu_up&amp;path=" . $path . "&amp;p0=". replaceWhitespace( $db->f( "name" )) .  "\">Hoch</a> /" .
              " <a href=\"?site=menu_down&amp;path=" . $path . "&amp;p0=" . replaceWhitespace( $db->f( "name" )) .  "\">Runter</a> )</td>" .
              "<td>( <a href=\"?site=menu_del&amp;path=" . $path . "&amp;p0=" . replaceWhitespace( $db->f( "name" )) .  "\" onclick=\"return sendFormular();\">Lschen</a> )</td></tr>";
  }
  $content.="</table>";
} else if ( $site == "menu_edit" ) {
  if( !isset( $path ))
    $path = initVar( "path", "" );
  $db->query( "SELECT `id`, `href` FROM `menu` WHERE `path` = '" . $path . "' AND `lang` = '" . $lang . "' AND `name` = '". $p0 . "'" );
  $menu_name = "Neuer Menpunkt";
  $menu_href = "";
  if( $db->next_record()) {
    $menu_name = $p0;
    $menu_href = $db->f( "href" );
    $menu_id = $db->f( "id" );
  }
  $content .= "<form action=\"?site=menu_save\" method=\"post\">"
            . "<input type=\"hidden\" name=\"path\" value=\"" . $path . "\" />"
            . "<table class=\"bt\"><tr><td>Name: </td><td><input type=\"text\" name=\"menu_name\" value=\""
             . $menu_name . "\" /></td></tr><tr><td>Ziel: </td><td><input type=\"text\" name=\"menu_href\""
             . " value=\"" . $menu_href. "\" />
             </td></tr><tr><td colspan=\"2\"><input type=\"hidden\" name=\"menu_id\" value=\"" . $menu_id . "\" /><input type=\"submit\" value=\"Speichern\" /> <input type=\"reset\" value=\"Original\" /></td></tr></table></form>";

} else if ( $site == "images" ) {
  $imgdir = dir('../../userdata/img/');
  $content .= "<br /><form enctype=\"multipart/form-data\" action=\"?site=image_upload\" method=\"post\">"
            . "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"3072000\"  accept=\"image/*\" />"
            . "Neues Bild hinzufgen: <input name=\"image\" type=\"file\" value=\"Durchsuchen...\" />"
            . " &nbsp; <input type=\"submit\" value=\"Hochladen\" /></form>";
  $content .= "<table class=\"bt\">";
  while($file = $imgdir->read()) {
    if( $file == "." || $file == ".." ) continue;
    $content .= "<tr><td>&bull; <a target=\"_blank\" href=\"../../userdata/img/" . $file . "\">" . $file . "</a></td>"
              . "<td>( <a href=\"?site=image_delete&amp;p0=" . $file .  "\" onclick=\"return sendFormular();\">Lschen</a> )</td></tr>";
  }
  $content.="</table>";
  $imgdir->close();

} else if ( $site == "files" ) {
  $imgdir = dir('../../userdata/files/');
  $content .= "<br /><form enctype=\"multipart/form-data\" action=\"?site=file_upload\" method=\"post\">"
            . "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"3072000\" />"
            . "Neue Datei hinzufgen: <input name=\"file\" type=\"file\" value=\"Durchsuchen...\" />"
            . " &nbsp; <input type=\"submit\" value=\"Hochladen\" /></form><br />";
  $content .= "<table class=\"bt\">";
  $sumcount = 0;
  while($file = $imgdir->read()) {
    if( $file == "." || $file == ".." ) continue;
    $db->query( "SELECT `count` FROM `count` WHERE `filename` = '" . $file . "'" );
    if( $db->next_record() ) {
      $count = $db->f( "count" );
    } else {
      $count = 0;
    }
    $sumcount += $count;
    $content .= "<tr><td>&bull; <a target=\"_blank\" href=\"../../userdata/files/" . $file . "\">" . $file . "</a></td>"
              . "<td>( <a href=\"?site=file_delete&amp;p0=" . $file .  "\" onclick=\"return sendFormular();\">Lschen</a> )</td>"
              . "<td>(Downloads: " .  $count . ")</td></tr>";
  }
  $content .= "<tr><td colspan=\"3\">&nbsp;</td></tr>";
  $content .= "<tr><td colspan=\"2\">Gesamt:</td><td>(Downloads: " . $sumcount . ")</td></tr>";
  $content .= "</table>";
  $imgdir->close();
}

$ctemplate = new myAdminSmarty;
$ctemplate->assign( "content", $content );
$ctemplate->assign( "pagetitle", "Administration [" . $lang . "]" );
$content = $ctemplate->fetch( "content.tpl" );


if( $xerr ) {
  getAdminSmarty( );
  $smarty->assign( "error", $xerr );
  $content = $smarty->fetch( "error.tpl" );

}

getAdminSmarty( );
$smarty->assign( "pagetitle", "Administration [" . $lang . "]" );
$smarty->assign( "lang_urls", $lang_urls );
$smarty->assign( "lang_names", $lang_names );
$smarty->assign( "lang_imgs", $lang_imgs );
$smarty->assign( "lang_selected", $lang_selected );
$smarty->assign( "menu_urls", array( $menu_urls ));
$smarty->assign( "menu_names", array( $menu_names ));
$smarty->assign( "menu_selected", array( $menu_selected ));
$smarty->assign( "content", $content );
$smarty->display( "main.tpl" );
?>
